{extends file="layout/errors.layout.tpl"}
{block name="content"}
  <div class="row">
    <div class="col-lg-12">
      
      <h1 class="page-header">
        {$Site->Config('ru.error')}
      </h1>
      
      <ol class="breadcrumb">
        <li><a href="/">{$Site->Config('ru.sys.main_page')}</a></li>
        <li class="active">{$Site->Config('ru.error')}</li>
      </ol>
    </div>
      
  </div>
  
  <div class="row">
    <div class="col-lg-12">
      
      {assign var=ConverterError value=0}
      
      {if $Site->ConverterErrors->Count}
        <table class="table table-striped table-bordered table-hover">
          <thead>
            <tr>
              <th>{$Site->Config('ru.converter.title')}</th>
              <th>{$Site->Config('ru.converter.is_excluded_title')}</th>
              <th>{$Site->Config('ru.converter.meters')}</th>
              <th>{$Site->Config('ru.converter.error_meters')}</th>
            </tr>
          </thead>
          <tbody>
            {foreach from=$Site->ConverterErrors->Elements item="iConverter"}
            
              {assign var="Meters" value=$iConverter->Meters->Count}
              {assign var="MetersError" value=$iConverter->MetersError->Count}
              
              {if !$Meters || !$MetersError}
                {continue}
              {/if}
              
              {assign var=ConverterError value=$ConverterError+1}
            
              <tr>
                <td>
                  {include 
                      file="converter/helpers/block_name.tpl"
                      oConverter=$iConverter
                  }
                </td>
                <td>
                  {$iConverter->IsExcludedTitle}
                </td>
                <td>
                  {$Meters}
                </td>
                <td>
                  {$MetersError}
                </td>
              </tr>
            {/foreach}
            
            {if !$ConverterError}
              <tr>
                <td colspan="6">
                  У вас есть конверторы, видимо на них нет приборов учета.
                </td>
              </tr>
            {/if}
            
          </tbody>
        </table>
      {else}
        <div class="alert alert-success">
          {$Site->Config('ru.error.null','В системе нет ошибок')}
        </div>
      {/if}
    </div>
  </div>
{/block}