{extends file="layout/meter.layout.tpl"}
{block name="content"}

  {assign var=oMeter value=$oObject}

  <h1 class="page-header">
    Прибор учета {$oMeter->Title|escape} 
  </h1>
  
  
  <ol class="breadcrumb">
    <li><a href="/">{$Site->Config('ru.sys.main_page')}</a></li>
    <li>
      {include file="converter/helpers/block_name.tpl" oConverter=$oMeter->Converter}
    </li>
    <li>
      {include file="meter/helpers/block_name.tpl"}
    </li>
    <li class="active">
      Лог
    </li>
  </ol>


  {if $Self->IsAdmin}
    <ul class="nav nav-tabs">
      <li class="active">
        <a href="{$oObject->LinkLog}">
          Пользовательский журнал
        </a>
      </li>
      {if property_exists($oObject,'GetSysLog')}
        <li><a href="{$oObject->LinkSysLog}">Системный журнал</a></li>
      {/if}
      <li><a href="{$oObject->Link}syslog/">Системный журнал</a></li>
    </ul>
  {/if}


  <div class="container-fluid">
    <div class="row">
      <div class="col-lg-12">
          
          {if $oObject->LogList->Count}

            {include file="helpers/pagination.tpl" Pages=$oObject->LogPages}
            
            <ul class="milestones">
              {foreach from=$oObject->LogList->Elements item="iLog"}
                  <li>
                    <i class="milestone-{$iLog->CssColor} {$iLog->CssClassIcon}"></i>
                    <p>
                      {include file="user/helpers/block_name.tpl" oUser=$iLog->User}
                      <span class="pull-right text-muted small">
                        <em>
                          {$iLog->Its|date_format:"%Y-%m-%d %H:%I:%S (%A)"}
                        </em>
                      </span>
                    </p>
                    {if $iLog->Object == 'meter' && $iLog->Property == 'Delete'}
                      <button type="button" class="btn btn-default btn-xs spoiler-trigger" data-toggle="collapse">
                        Подробнее <i class="fa  fa-angle-down"></i> 
                      </button>
                      <pre class="collapse out">{assign var="cl" value=$iLog->Object}{var_export(json_decode($cl::Id($iLog->ObjectId)->Title))}</pre>
                    {elseif $iLog->Property == 'Update' || $iLog->Property == 'Add'}
                      <button type="button" class="btn btn-default btn-xs spoiler-trigger" data-toggle="collapse">
                        Подробнее <i class="fa  fa-angle-down"></i>
                      </button>
                      <div class="collapse out">{$iLog->ActionToTpl}</div>
                    {else}
                      {$iLog->ActionToTpl}
                    {/if}
                  </li>
              {/foreach}
            </ul>

            {include file="helpers/pagination.tpl" Pages=$oObject->LogPages}

          {else}
            <h3>Еще ничего не происходило.</h3>
          {/if}
          
      </div>
    </div>
  </div>


  {literal}
    <script>
      $(".spoiler-trigger").click(function() {
        $(this).next().collapse('toggle');
      });
    </script>
  {/literal}
  
  
{/block}
