<div id="app"></div>

<script type="text/template" id="counter">

  <% if( model.get_issues_run_w() ){ %>
  <div class="progress">
    <div class="progress-bar" role="progressbar" aria-valuenow="70"
    aria-valuemin="0" aria-valuemax="100" style="width:<%= 100/model.get('issues').length*model.get('issues').where({ status : "SUCCESS" }).length %>%">
      <span class="sr-only"><%= 100/model.get('issues').length*model.get('issues').where({ status : "SUCCESS" }).length %>% Complete</span>
    </div>
  </div>
  <% } %>
  
  <% if( model.get('is_edit') ){ %>

  <div class="wrapper">
    <p class="h2 page-header">
      Страница конфигурации импульсных входов SNR-RScounter-8I
    </p>
          <div class="form-group">
      <label for="ip" class="control-label">Ip адрес: *</label>
      <input id="ip" value="<%= model.get('ip') %>" class="form-control" placeholder="127.0.0.1">
    </div>
      <div class="form-group">
      <label for="port" class="control-label">Порт: *</label>
      <input id="port" value="<%= model.get('port') %>" class="form-control" placeholder="50">
    </div>
      <div class="form-group">
      <label for="mac" class="control-label">Mac(hex): *</label>
      <input id="mac" value="<%= model.get('mac') %>" class="form-control" placeholder="01:02:03:04:05:06:07:08:09:FF"/>
      <span class="small text-muted">Пример: 01:02:03:04:05:06:07:08:09:FF</span>
    </div>
      <div class="form-group">
      <label for="pass" class="control-label">Пароль: *</label>
      <input id="pass" value="<%= model.get('pass') %>" class="form-control" placeholder="01:02:03:04:05:06:07:08:09:FF"/>
      <span class="small text-muted">Пример: 01:02:03:04:05:06:07:08:09:FF</span>
    </div>  
    <button id="send" class="btn btn-disabled">Продолжить</button>
  </div>
  
  <% }else{ %>
          
    <% _.each( model.get('log').where({ type : "main" }) , function( log ){ %>
        <div class="alert alert-danger"><%= log.get('msg') %></div>
     <% }) %>
  
    <div class="row">
      <div class="col-lg-6">
      <br>
      <div id="parameters" style="display: block;">

        <div class="panel panel-default">
          <div class="panel-heading">
            Информация о устройстве
          </div>
          <div class="panel-body">
            <table class="table table-responsive">
              <tbody>
                <tr>
                  <td>IP</td>
                  <td><%= model.get('ip') %></td>
                </tr>
                <tr>
                  <td>Port</td>
                  <td><%= model.get('port') %></td>
                </tr>
                <tr>
                  <td>Mac(hex):</td>
                  <td><%= model.get('mac') %></td>
                </tr>
                <tr>
                  <td>Пароль:</td>
                  <td><%= model.get('pass') %></td>
                </tr>
              </tbody>
            </table>
          </div>
          <div class="panel-footer">
            <button id="edit" class="btn btn-info" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Изменить</button>
            <button id="reset_value" class="btn btn-info" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Обновить</button>
          </div>
        </div>

      </div>
      
    </div>
        <div class="col-lg-6">
        <br>
          <div class="panel panel-default">
            <div class="panel-heading">
            Свойтсва устройства
            </div>
            <div class="panel-body">
              <table class="table table-responsive">
                <tbody>
                  <tr>
                    <td>Идентификатор устройства</td>
                    <td id="ident_res">
                      <%= model.get('ident') %>
                      </td>
                  </tr>
                  <tr>
                    <td>Версия прошивки</td>
                    <td id="version">
                      <%= model.get('version') %>
                    </td>
                  </tr>
                  <tr>
                    <td>Время на сервере</td>
                    <td id="server_time">
                      <%= model.get('time_server') %>
                    </td>
                  </tr>
                  <tr>
                    <td>Время на устройстве</td>
                    <td id="device_time">
                      <%= model.get('time_device') %>
                    </td>
                  </tr>
                </tbody>
              </table>
          </div>
          <div class="panel-footer">
            <button id="set_pass" class="btn btn-primary" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Установить Пароль</button> 
              <button id="set_time" class="btn btn-primary" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Установка времени</button>
          </div>
        </div>

        </div>
      </div>
      
      <div class="row">
        <div class="col-lg-12">

          <div class="panel panel-default">
            <div class="panel-heading">
              Редактирование параметров
              <div class="pull-right">
                <button class="btn btn-xs btn-info" id="advanced_mode" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>
                  <% if( !model.get('advanced_mode') ){ %>
                    Расширенный режим
                  <% }else{ %>
                    Убрать расширенный режим
                  <% } %>
                  </button>
              </div>
            </div>
            <div class="panel-body  table-responsive">
              <table id="coefs_block" class="table">
              <thead>
                <tr>
                <td class="h"></td>
                <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                  <th class="h edit_chan" data-chanel="<%= chanel.cid %>">
                    <% if( chanel.is_error() ) { %>
                      ошибка
                    <% }else if( chanel.is_waiting() ){ %>
                      Ожидает
                    <% }else if( chanel.is_running() ){ %>
                      Выполняется
                    <% }else{ %>
                      <button class="btn btn-xs" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Изменить</button>
                    <% } %>
                  </th>
                <% }) %>
                </tr>
                <tr>
                <td></td>
                <% _.each( model.get('chanels').toArray() , function( chanel , i ){ %>
                  <td>
                    DI<%= i+1 %>
                  </td>
                <% }) %>
                </tr>
              </thead>
              <tbody>
                <!-- <tr>
                  <td>
                    Показания прибора на момент фиксации срезов
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td data-chanel="<%= chanel.cid %>">
                      <% if( chanel.get('data_counter') ){ %> <%= chanel.get('data_counter') %> <% } %>
                    </td>
                  <% }) %>
                </tr> -->
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    Срезы в импульсах
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_section_imp">
                      <%= chanel.get('section_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Срезы
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_section_user_v">
                      <%= chanel.get('section_user_v') %>
                    </td>
                  <% }) %>
                </tr>
                <tr>
                  <td>
                    Множитель импульса
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td data-chanel="<%= chanel.cid %>">
                      <%= chanel.get('math') %>
                    </td>
                  <% }) %>
                </tr>
                <tr>
                  <td>
                    Делитель имупульса
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td data-chanel="<%= chanel.cid %>">
                      <%= chanel.get('divider') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Дельта с прибора
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_delta_imp">
                      <%= chanel.get('delta_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Цена импульса
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_price_imp">
                      <%= chanel.get('price_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr>
                  <td >
                    Текщие показания
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td id="t_cid<%= chanel.cid %>_value_now">
                      <%= chanel.get('value_now') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Дельта в пользовательских величинах
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_delta_user_v">
                      <%= chanel.get('delta_user_v') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Дельта в импульсах
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_delta_imp">
                      <%= chanel.get('delta_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    Должно быть
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active"   id="t_cid<%= chanel.cid %>_res_user_v">
                      <%= chanel.get('res_user_v') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Должно быть импульсах
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active"  id="t_cid<%= chanel.cid %>_res_imp">
                      <%= chanel.get('res_imp') %>
                    </td>
                  <% }) %>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
        </div>
      </div>
      <div class="container_debug">
        <button class="btn btn-default" id="view_log" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Показать лог</button>
        <button class="btn btn-default" id="clear_log" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Очистить лог</button>
      </div>
      <% if( model.get('is_view_log') ){ %>
        <div id="debug" class="panel-body">
          <% _.each( model.get('log')._sort_by_issues() , function( log_group ){ %>
            <% var log_last = log_group[log_group.length-1]; %>
            <b><%= log_last.get("reason") %> <%= log_last.get("chanel") %></b><br>
            <% _.each( log_group , function( log ){ %>
              <% if( log.get("is_in") === true ){ %>
                <i class="date">&gt;&gt; <%= log_last.get("time") %></i>
              <% }else if( log.get("is_in") === false ){ %>
                <i class="date">&lt;&lt; <%= log_last.get("time") %></i>
              <% } %>
              <%= log.get("msg") %><br>
            <% }) %>
            <hr>
          <% }) %>
        </div>
      <% } %>
  <% } %>
  
</script>
          
          
<script type="text/template" id="modal_pass_tpl">
  <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
          <h4 class="modal-title" id="myModalLabel">

              Установка пароля

          </h4>
        </div>
        <div class="modal-body">
          <div class="form-group">
            <label for="pwd">Новый пароль (HEX):</label>
            <input class="form-control" id="new_pass" placeholder="01:02:03:04:05:06:07:08:09:FF" value="<%= counter.get('pass') %>">
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">Закрыть</button>
          <button type="button" class="btn btn-primary" id="save_new_pass">Сохранить</button>
        </div>
      </div>
    </div>
  </div>
</script>

          
          
<script type="text/template" id="set_date_tpl">
  <div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
          <h4 class="modal-title" id="myModalLabel">
              Установка времени
          </h4>
        </div>
        <div class="modal-body">
          <div class="form-group">
            <label for="pwd">Дата:</label>
            <input class="form-control" type="date" value="<%= date %>" id="input_date"/>
          </div>
          <div class="form-group">
            <label for="pwd">Время:</label>
            <input class="form-control" type="time" value="<%= time %>" id="input_time"/>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">Закрыть</button>
          <button type="button" class="btn btn-primary" id="save_new_date">Сохранить</button>
        </div>
      </div>
    </div>
  </div>
</script>


<script type="text/template" id="modal_tpl">
      <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
              <h4 class="modal-title" id="myModalLabel">
                  
                  Канал : <%= chanel.collection.indexOf(chanel)+1 %>

              </h4>
            </div>
            <div class="modal-body">
              
                <table id="coefs_block" class="table table-responsive">
              <tbody>
                <tr>
                  <td>
                    Показания прибора на момент фиксации срезов *
                  </td>
                    <td data-chanel="<%= chanel.cid %>">
                      <input type="text" class="data_counter form-control" value="<%= chanel.get('data_counter') %>" 
                      <% if( chanel.get('math') === null ){ %>disabled<% } %>/>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    Срезы в импульсах
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_section_imp">
                      <%= chanel.get('section_imp') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Срезы
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_section_user_v">
                      <%= chanel.get('section_user_v') %>
                    </td>
                </tr>
                <tr>
                  <td>
                    Множитель импульса *
                  </td>
                    <td data-chanel="<%= chanel.cid %>">
                      <input type="text" class="math form-control" value="<%= chanel.get('math') %>" 
                      <% if( chanel.get('math') === null ){ %>disabled<% } %>/>
                    </td>
                </tr>
                <tr>
                  <td>
                    Делитель имупульса *
                  </td>
                    <td data-chanel="<%= chanel.cid %>">
                      <input type="text" class="divider form-control" value="<%= chanel.get('divider') %>" 
                      <% if( chanel.get('math') === null ){ %>disabled<% } %>/>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Дельта с прибора
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_delta_counter">
                      <%= chanel.get('delta_counter') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Цена импульса
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_price_imp">
                      <%= chanel.get('price_imp') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Текщие показания
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_value_now">
                      <%= chanel.get('value_now') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Дельта в пользовательских величинах
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_delta_user_v">
                      <%= chanel.get('delta_user_v') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Дельта в импульсах
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_delta_imp">
                      <%= chanel.get('delta_imp') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    Должно быть
                  </td>
                    <td class="active"   id="cid<%= chanel.cid %>_res_user_v">
                      <%= chanel.get('res_user_v') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    Должно быть импульсах
                  </td>
                    <td class="active"  id="cid<%= chanel.cid %>_res_imp">
                      <%= chanel.get('res_imp') %>
                    </td>
                </tr>
              </tbody>
            </table>




            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-default" data-dismiss="modal">Закрыть</button>
              <button type="button" class="btn btn-primary" id="save">Сохранить</button>
            </div>
          </div>
        </div>
      </div>
    </script>


{literal}
<style>
    i.date {
    font-size: x-small;
    color: grey;
    
}
</style>
{/literal}