var GATAWAY_MODEL = Backbone.Model.extend({

  defaults : {
    active: false,
    downlinkChannel: 0,
    extraInfo: "",
    gatewayId: "",
    latency: 0,
    maxPower: 0,
    rxOnly: false,
    companionGateway : ""
  },

  validate : function(){
    if( !this.__validate_gatawayId() ){
        return "invalid gatawayID"
    }
    if( !this.__validate_companionGateway() ){
        return "invalid gatawayID"
    }

    if( !this.__validate_maxPower() ){
        return "invalid maxPower"
    }
  },

  __validate_gatawayId : function(){
    return this.get('gatewayId').toUpperCase().match(/^([A-F|0-9]{16})$/) !== null
  },

  __validate_companionGateway : function(){
    return this.get('companionGateway').toUpperCase().match(/^([A-F|0-9]{16})$/) !== null
  },

  __validate_maxPower : function(){
    return this.get('maxPower') >= 0
  }

})