/*
 * 
 * Вид отвечает за построение списка приборо учета на базовой станции
 * 
 */
 var VIEW_LORA_DEVICES = Backbone.View.extend({

  el : "#lora_meters",

  template : "#lora_meters_tpl",

  initialize : function( _meters , _meter_types , _lora_devices , _lora_devices_types , _base_station , _lora_types ){
    this.collection         = _meters
    this.collection_types   = _meter_types
    this.lora_devices       = _lora_devices
    this.lora_devices_types = _lora_devices_types
    this.base_station       = _base_station
    this.lora_types         = _lora_types

    this.listenTo( this.collection , "sync"  , this.render )

    this.render()
  },

  render : function(){


    var tpl_c = _.template( $(this.template).html() )
    $(this.$el).empty().append( tpl_c({
      my_meters : this.collection.toArray(),
      types     : this.collection_types
    }) )
  },


  events : {

    "click .converter_meter_edit" : function( e ){

      var cid = $( e.target ).closest('tr').attr('id')

      var this_meter = this.collection.get( cid )

      var lora_meter = this.lora_devices.findWhere({ devEui : this_meter.get('num_serial') })

      try{

        if( typeof ( this_meter || METER_MODAL_EDIT ) == "undefined" ){
          return false
        }
        new METER_MODAL_EDIT( this_meter , this.collection_types , lora_meter, this.lora_types , this.base_station , this.lora_devices_types  );
      }catch( e ) {
        return false;
      }
      return false;
    },

    "click #lora_add_meter" : function(){
      new METER_MODAL_EDIT( new METER_MODEL , this.collection_types , new LORA_DEVICE, this.lora_types , this.base_station , this.lora_devices_types  );
      return false;
    },


    "click .converter_meter_delete" : function( e ){
      var cid = $( e.target ).closest('tr').attr('id')
      var this_meter = this.collection.get( cid )
      var lora_meter = this.lora_devices.findWhere({ devEui : this_meter.get('num_serial') })

      var self = this;

      this_meter.on('remove' , function(){
        self.lora_devices.remove(lora_meter)
        self.base_station.delete_device(lora_meter)
      })

      new METER_MODAL_DELETE( this_meter , this.collection )
      return false;
    }

  }


})