var GATAWAY_MODAL_EDIT = Backbone.View.extend({

  template : "#gataway_settings_tpl",

  model : new GATAWAY_MODEL,

  initialize : function( gataway , base_station ){
    this.origin = gataway
    this.base_station = base_station
    this.model = gataway.clone()

    this.listenTo( this.model , 'change' , this.__btn_status)

    this.listenTo( this.model , 'change:rxOnly' , function(){
      $("#companionGateway").attr('disabled' , this.model.get('rxOnly') ? null : "disabled")
    })
    this.render()
  },

  render : function(){
    var tpl_c = _.template( $(this.template).html() )
    this.$el = $(tpl_c({
      gataway : this.model
    })).modal('show')

    var self = this

    $(this.$el).on('shown.bs.modal' , function(){
      self.__btn_status()
    }).on('hidden.bs.modal' , function(){
      $(this).remove()
    })
  },

  __btn_status : function(){
    if(  this.model.isValid() ){
      $("#save").removeClass('btn-disabled').addClass('btn-success')
    }else{
      $("#save").addClass('btn-disabled').removeClass('btn-success')
    }
  },

  events : {
    "keyup #Gateway_ID_input" : function( e ){
      this.model.set('gatewayId' , $(e.target).val())
    },
    "keyup #maxPower" : function( e ){
      this.model.set('maxPower' , $(e.target).val())
    },
    "change #rxOnly" : function( e ){
      this.model.set('rxOnly' , $(e.target).prop('checked'))
    },
    "keyup #companionGateway" : function( e ){
      this.model.set('companionGateway' , $(e.target).val())
    },
    "keyup #extraInfo" : function( e ){
      this.model.set('extraInfo' , $(e.target).val())
    },
    "click #save" : function( e ){
      this.base_station.save_gataways( this.model )
      $(this.$el).modal('hide')
    }
  }
})