/*
 * 
 * Вид отвечает за вывод информации о БС в табличном виде
 * 
 */

 var LORA_TABLE_INFO = Backbone.View.extend({

  connect_status : false,

  status_auth : false,

  status_active : false,


  el : "#lora_properties",
  
  template : "#lora_properties_tpl",
  
  model : new LORA_CONVERTER,
  
  collection : new ConverterTypes,
  
  

  /*
   * @param Backbone.Model
   * @param Backbone.Collection
   * 
   * @return LORA_TABLE_INFO
   */
   initialize : function( _model , collection_types ){

    this.model = _model
    this.collection_types = collection_types

    this.listenTo( this.model , "sync" , this.render );

    this.listenTo( this.model , "connect" , function( status_connect ){
      this.connect_status = status_connect
      this.render();
    });

    this.listenTo( this.model , "active" , function( status_active ){
      this.status_active = status_active
      this.render();
    });

    this.listenTo( this.model , "auth" , function( status_auth ){
      this.status_auth = status_auth
      this.render();
    });

    this.listenTo( this.model , "message" , function( message ){
      var self = this;

      try{
        var data = JSON.parse( event.data )

        switch( data.cmd ){
          case "get_gateways_resp" :
            var first_bs = data.gateway_list.shift()
            if( typeof first_bs != "undefined" ){
              self.status_active = first_bs.active
            }
          break;
        }
      }catch(e){
        console.log(e)
      }
      this.render();
    });


    // this.listenTo( this , "acivity" , this.render );
    
    if( typeof collection_types !== "undefined" ){
      this.collection = collection_types;
    }
    
    if( typeof model !== "undefined" ){
      this.model = model;
    }
    
    
    if( !$( this.template ).length ){
      return this;
    }
    
    this.render();
    
  },
  
  
  render : function(){

    var tpl_c = _.template( $( this.template ).html() );
    $( this.$el ).empty().append( tpl_c( { 
      lora_model      : this.model , 
      connect_status  : this.connect_status,
      status_auth     : this.status_auth,
      status_active   : this.status_active
    } ) );
  },

  events : {
    "click #converter_edit_modal" : function(){
      new LORA_EDIT_ADD_MODAL(this.model , null)
      return false
    }
  }
  
});
