var LORA_METER_MAIN_INFO_VIEW = Backbone.View.extend({

    el : "#container_meter_info",

    template : "#meter_main_info_tpl",

    model : new METER_MODEL,

    /*

        @param  Объект прибора который храниться у нас в БД
        @param Объект который храниться у веги
        @param Типы приборов в нашей БД
        @param Типы приборов у веги
        @param Базовая станция
        @param Связи приборов и типов

    */
    initialize : function( meter_ , _lora_model, _model_types , _lora_types, _base_station, _lora_device_types ){
        this.model = meter_
        this.lora_model = _lora_model
        this.model_types = _model_types
        this.lora_types = _lora_types
        this.base_station = _base_station
        this.lora_device_types = _lora_device_types
        this.listenTo( this.model , "sync" , this.render )
        this.render()
    },

    render : function(){
        var tpl_c = _.template( $(this.template).html() )
        $(this.$el).empty().append( tpl_c({ meter : this.model }) )
    },

    events : {
        "click .block_meter_edit" : function(){
            new METER_MODAL_EDIT( this.model , 
                this.model_types, 
                this.lora_model, 
                this.lora_types, 
                this.base_station, 
                this.lora_device_types )
            return false;
        }
    }

})


var lora_device = new LORA_DEVICE() 

var lora_devices_types = new LORA_DEVICE_TYPES
  
base_station.on("sync" , function(){
    if( this.get('ip') != this.defaults.ip && this.get('port') != this.defaults.port ){
      this.connect()
    }
  })
  // Как только смогли соединится, сразу пытаемся аторизоваться
  .on('connect' , function( status_connect ){
    this.is_socket_connect = status_connect
    if( status_connect ){
      this.auth()
    }
  })
  // Как только авторизовались, то нам надо получить список БС на сервере приложений
  .on('auth' , function( status_auth ){
    var self = this;
    if( status_auth ){
      this.socket.addEventListener("message" , function( event ){
        self.trigger( "message" , event )
      })
      this.get_gataways()
    }
  })
  // Дальше слушаем все сообьщения с БС
  .on('message' , function( event ){
  
    var self = this;
  
    try{
      var data = JSON.parse( event.data )
  
      switch( data.cmd ){
  
        // Запросили список БС? - Запрашиваем список приборов
        case "get_gateways_resp" :
          self.get_devices()
          self.get_device_appdata()
        break;
        case "manage_devices_resp" :
          self.get_devices()
          self.get_device_appdata()
        //   meters.fetch()
        break;
        case "get_devices_resp":
            lora_device.initialize(_.findWhere( data.devices_list , { devEui : meter.get('num_serial') } )  )
        break;
        case "delete_devices_resp":
        //   meters.fetch()
          self.get_devices()
          self.get_device_appdata()
        break;
        case "get_device_appdata_resp":
          lora_devices_types.reset()
          lora_devices_types.add( data.devices_list )
        break;
        default :
          console.log( data.cmd )
        break;
      }
    }catch(e){
      console.log(e)
    }
  })

  var meter_types = new MeterTypes();

  meter_types.fetch();


  var lora_types = new LORA_TYPES([
    {
      id: 1,
      name: 'СИ-11',
      count_channels: 4
    }, {
      id: 3,
      name: "СИ-13 Меркурий",
      count_channels: 6
    }, {
      id: 4,
      name: "ТД-11",
      count_channels: 1
    }, {
      id: 5,
      name: "ТП-11",
      count_channels: 1
    }, {
      id: 6,
      name: 'MC-0101',
      count_channels: 1
    }, {
      id: 7,
      name: 'AS-0101',
      count_channels: 1
    }, {
      id: 8,
      name: 'MS-0101',
      count_channels: 1
    }, {
      id: 9,
      name: "СВЭ1",
      count_channels: 1
    }, {
      id: 10,
      name: 'SS-0101',
      count_channels: 1
    }, {
      id: 11,
      name: "СИ-21",
      count_channels: 4
    }, {
      id: 12,
      name: "Электросчетчик",
      count_channels: 1
    }, {
      id: 13,
      name: 'GM-2',
      count_channels: 1
    }, {
      id: 14,
      name: 'LM-1',
      count_channels: 1
    }
  ]);


$(document).ready(function () {
    meter.fetch()
    base_station.fetch()
    new LORA_METER_MAIN_INFO_VIEW( meter , lora_device, meter_types , lora_types, base_station, lora_devices_types )
})