var deviceTypes = new LORA_TYPES([
  {
    id: 1,
    name: 'СИ-11',
    count_channels: 4
  },{
    id: 3,
    name: "СИ-13",
    count_channels: 6
  },{
    id: 4,
    name: "ТД-11",
    count_channels: 1
  }, {
    id: 5,
    name: "ТП-11",
    count_channels: 1
  }, {
    id: 6,
    name: 'MC-0101',
    count_channels: 1
  }, {
    id: 7,
    name: 'AS-0101',
    count_channels: 1
  }, {
    id: 8,
    name: 'MS-0101',
    count_channels: 1
  }, {
    id: 9,
    name: "СВЭ1",
    count_channels: 1
  }, {
    id: 10,
    name: 'SS-0101',
    count_channels: 1
  }, {
    id: 11,
    name: "СИ-21",
    count_channels: 4
  }, {
    id: 12,
    name: "Электросчетчик",
    count_channels: 1
  }, {
    id: 13,
    name: 'GM-2',
    count_channels: 1
  }, {
    id: 14,
    name: 'LM-1',
    count_channels: 1
  }
]);

// Базовая станция в представлении веги
var lora_model = new LORA_CONVERTER({ id : lora_id });

// Приборы в неашем представлении
var meters = new METERS();

// приборы в представлении веги
var lora_devices = new LORA_DEVICES;


var lora_devices_types = new LORA_DEVICE_TYPES();


var meter_types = new MeterTypes();

// Подгружаем информационну таблицу
var view_info_table = new LORA_TABLE_INFO( lora_model, meter_types );

meter_types.fetch();

var gataways = new GATAWAY_COLLECTION


// Когда все приборы были ссинхронизированы
// то надо перезапросить список

// Общие правила поведения синхронизации БС


/*
  
  Как только поменялись ip и порт то нам надо подключится
  Далее будет включен надор правил синхронизации

  Првоеряем что порт и айпишник не пустые и как только можно подключится, то подключаемся
  Выключаем правила чтобы не дублировать соединения

*/
lora_model.on("sync" , function(){
  if( this.get('ip') != this.defaults.ip && this.get('port') != this.defaults.port ){
    this.connect()
  }
})
// Как только смогли соединится, сразу пытаемся аторизоваться
.on('connect' , function( status_connect ){
  this.is_socket_connect = status_connect
  if( status_connect ){
    this.auth()
  }
})
// Как только авторизовались, то нам надо получить список БС на сервере приложений
.on('auth' , function( status_auth ){
  var self = this;
  if( status_auth ){
    this.socket.addEventListener("message" , function( event ){
      self.trigger( "message" , event )
    })
    this.get_gataways()
  }
})
// Дальше слушаем все сообьщения с БС
.on('message' , function( event ){

  var self = this;

  try{
    var data = JSON.parse( event.data )

    switch( data.cmd ){

      // Запросили список БС? - Запрашиваем список приборов
      case "get_gateways_resp" :
        gataways.reset().add(data.gateway_list)
        self.get_devices()
        self.get_device_appdata()
      break;
      case "manage_devices_resp" :
        self.get_devices()
        self.get_device_appdata()
        meters.fetch({url : "/api/?object=meter&filter=converter_id:" + lora_id})
      break;
      case "get_devices_resp":
        lora_devices.reset()
        lora_devices.add( data.devices_list )
      break;
      case "delete_devices_resp":
        meters.fetch({url : "/api/?object=meter&filter=converter_id:" + lora_id})
        self.get_devices()
        self.get_device_appdata()
      break;
      case "get_device_appdata_resp":
        lora_devices_types.reset()
        lora_devices_types.add( data.devices_list )
      break;
      case "manage_gateways_resp":
        self.get_gataways()
      break;
      case "delete_gateways_resp":
        self.get_gataways()
      break;
      default :
        console.log( data.cmd )
      break;
    }
  }catch(e){
    console.log(e)
  }
})


meters.on("sync" , function(){
  lora_model.get_devices()
  lora_model.get_device_appdata()
})


$(document).ready(function(){

  new VIEW_LORA_DEVICES( meters , meter_types , lora_devices , lora_devices_types , lora_model , deviceTypes );
  new UNDEFINED_DEVICES_VIEW( lora_devices , deviceTypes , lora_devices_types, meters, lora_model );
  new GATAWAYS_LIST( gataways , lora_model );

  lora_model.fetch()
  meters.fetch({ url : "/api/?object=meter&filter=converter:" + lora_id })

})


/*

eu
FIZED [*]
FIZED [*]
FIZED [*]
867100000 [*]
867300000 [*]
867500000 [*]
867700000 [*]
867900000 [*]

RX 869525000




ru
FIZED [*]
FIZED [*]
FIZED [*]
864100000 [*]
864300000 [*]
868800000 [*]
0 [*]
0 [*]

RX 869050000

*/