/*
  
  Вид для показа пользователю что есть у него несинхронизированные приборы или нет

  @param _unsync_devices  {Collection} Все приборы, которые надо синхронизировать
  @param _types           {Collection} Все типы приборов
  @param _meter_types     {Collection} Все связи приборов с типами
  @param _meters          {Collection} Все приборы
  @param _base_station    {Model}      Модель БС

*/
var UNDEFINED_DEVICES_VIEW = Backbone.View.extend({

  // Приборы которые надо добавить к нам в систему
  collection    : new LORA_DEVICES(),
  // Приборы которые надо удалить у нас из системы
  rm_collection : new METERS(),
  model         : new LORA_CONVERTER(),
  types         : new LORA_TYPES(),
  meter_types   : new LORA_DEVICE_TYPES(),


  // Шаблон на случай если есть несмнхронизированные приборы
  template        : "#undefined_device_tpl",

  // Шаблон ожидания когда мы закончим проверять все ли приборы
  // ссинхронизированы
  wait_template   : "#undefined_device_wait_tpl",

  // Самый первый шаблон для показа что не нужнается в синхронизации
  // Стоит по умолчанию чтобы в случае поломки не выбешивать клиента
  el              : "#undefined_device",

  // Коллекция, которую будем наполнять устройствами
  // которые есть на лора сервер и нет у нас
  ar_not_sync     : new LORA_DEVICES,

 initialize : function( _lora_devices , _types , _meter_types , _meters , _base_station ){

    if( typeof ( _lora_devices || _types || _meter_types || _meters || _base_station ) == "undefined" ){
      return
    }
    
    this.model        = _base_station
    this.types        = _types
    this.meter_types  = _meter_types
    this.meters       = _meters
    this.lora_devices = _lora_devices


    this.listenTo( this.meters        , "remove" , this.render )
    this.listenTo( this.meters        , "add" , this.render )
    this.listenTo( this.lora_devices  , "add" , this.render )

  },


  // Когда все получено, то можно отрисовать
  render : function(){
    
    var self = this;

    this.rm_collection.reset()
    this.collection.reset()

    var remove_sync = _.filter( this.meters.toArray() , function( elem ){
      return typeof self.lora_devices.findWhere({ devEui : elem.get('num_serial') }) == "undefined"
    })
    for (var i = 0; i <= remove_sync.length - 1 ; i++) {
      this.rm_collection.add( remove_sync[i].toJSON() )
    }

    var not_sync = _.filter( self.lora_devices.toArray() , function( elem ){
      return typeof self.meters.findWhere({ num_serial : elem.get('devEui') }) == "undefined"
    })
    for (var i = 0; i <= not_sync.length - 1 ; i++) {
      this.collection.add( not_sync[i].toJSON() )
    }

    var tpl_c = _.template( $(this.template).html() )
    $( this.$el ).empty().append( tpl_c({ 
      devices       : this.collection,
      rm_collection : this.rm_collection
    }) )
  },


  events : {

    // Пользователь захотел посмотреть что ему надо синхронизировать
    "click #start_sync" : function(){
      new LORA_SYNC_DEVICES( this.collection , this.rm_collection , this.types , this.meter_types , this.model , this.meters )
    }
  }
})