var METER_MODAL_EDIT_VIEW = Backbone.View.extend({
  
  template : "#meter_edit_add_tpl",

  model : new METER_MODEL,

  collection : new METERS,

  models : new MODEL_COLLECTION,

  marks : new MARK_COLLECTION,


  converters : new CONVERTERS,

  mark_id : 0,

  change_mark : new MeterType,

  initialize : function( meter_ , meters_ , marks_ , models_ ){
    this.origin = meter_
    this.model = meter_.clone()
    this.collection = meters_
    this.marks = marks_
    this.models = models_

    var change_model =  this.models.findWhere( { type_id : Number( this.model.get('type') ) } )
    if( typeof change_model == "undefined" ){
      this.change_mark = new MeterType
    }

    this.change_mark = this.marks.findWhere({ id : change_model.get('mark_id') })

    this.render()
  },


  render : function(){
    var tpl_c = _.template( $(this.template).html() )
    this.$el = $( tpl_c({

      meter       : this.model,
      models      : this.models,
      marks       : this.marks,
      change_mark : this.change_mark,
      converters  : this.converters

    }) ).modal('show')

    var self = this

    $(this.$el).on('hidden.bs.modal' , function(){
      $(this).remove()
    }).on('shown.bs.modal' , function(){
      if( self.model.get('id') ){
        $('#meter_type').trigger('change')
      }
    })


    this.model.on('change' , function(){
      if( this.isValid() ){
        $("#save_meter").addClass('btn-success').removeClass('btn-disabled')
      }else{
        $("#save_meter").removeClass('btn-success').addClass('btn-disabled')
      }
    })

  },

  events : {
    "change #meter_type" : function( e ){
      this.mark_id = Number( $(e.target).val() )
      var tpl_c = _.template('<% _.each( models , function( model ){ %><option value="<%= model.get("id") %>" <% if( model_id == model.get("id") ){ %>selected<% } %>><%= model.get("title") %></option><% }) %>')
      $("#models_select").empty().append( 
        tpl_c({ 
          models : this.models.where({ mark_id :  this.mark_id }) , 
          model_id : Number( this.model.get('model') ) 
        }) 
      )
    },

    "click .more_settings_controller" : function(){

    },

    "keyup #about" : function( e ){
      this.model.set( 'about' , $(e.target).val() )
    },

    "keyup #num_serial" : function( e ){
      this.model.set( 'num_serial' , $(e.target).val() )
    },

    "keyup #num_485" : function( e ){
      this.model.set( 'num_485' , Number( $(e.target).val() ) )
    },

    "keyup #password" : function( e ){
      this.model.set( 'password' , $(e.target).val() )
    },

    "keyup #coef" : function( e ){
      this.model.set( 'coef' , Number( $(e.target).val() ) )
    },

    "change #timezone_id" : function( e ){
      this.model.set( 'timezone_id' , Number( $(e.target).val() ) )
    },

    "change #first_date_verification" : function( e ){
      this.model.set( 'first_date_verification' ,  $(e.target).val() )
    },

    "change #interval_verification" : function( e ){
      this.model.set( 'interval_verification' , $(e.target).val() )
    },

    "keyup #number_plomb" : function( e ){
      this.model.set( 'number_plomb' , Number( $(e.target).val() ) )
    },

    "change #is_excluded" : function( e ){
      this.model.set( 'is_excluded' , Number( $(e.target).prop('checked') ) )
    },

    "click #save_meter" : function(){
      var self = this
      this.origin.save( this.model.toJSON() , { success : function(){
        $(self.$el).modal('hide')
        self.collection.fetch()
      }})
    }

  }

})